"""
         Quantification of Categorical Data
                 Yasuharu Okamoto,
                 2023.08, 2023.11
"""
import pandas as pd
import numpy as np

fl_nm = input('Excel Input Data File(*.xlsx) = ')
xlfile = pd.ExcelFile(fl_nm)
df = pd.read_excel(xlfile)
fout_nm = input('Output File (*.txt) = ')
fout = open(fout_nm, 'w')
fout.write(f'Data file = {fl_nm}\n')

print('DataFrame =\n', df)
fout.write(f'data...\n{df}\n')
case_id = df.values.T[0][1:]
var_names = np.array(df.keys()[1:])
var_types = df.values[0][1:]
X = df.values[1:,1:]
#
#           Quantification
#
genvars = []
genX = []
n = len(case_id)
for i in range(len(var_names)):
    k = var_types[i]
    G = np.zeros((n, k))
    for j in range(n):
        G[j][X[j][i] - 1] = 1
    print('\n', var_names[i])
    print('G =\n', G)
    fout.write(f'\n{var_names[i]}')
    fout.write(f'\nG =\n')
    fout.write(f'{G}\n')
               
    f = np.reshape(np.sum(G, axis=0), (1, k))
    print('f =\n', f)
    fout.write(f'f =\n{f}\n')
    H = G - np.ones((n,1)) @ f / n
    vals, vecs = np.linalg.eig(H.T @ H)
    idxsort = np.argsort(-vals)
    vals = vals[idxsort]
    vecs = vecs.T[idxsort].T
    ck_k = np.sum([vals > 1.0e-9])
    print('ck_k =', ck_k)
    print(f'\n{var_names[i]}:')
    print('\nLambda...')
    for t in range(ck_k):
        print(f'{vals[t]:>20.3f}', end = '')
    print()
    fout.write('Lambda...\n')
    for t in range(ck_k):
        fout.write(f'{vals[t]:>20.3f}')
    fout.write('\n')
    print('Omega...\n')
    fout.write('Omega...\n')
    for t in range(k):
        for j in range(ck_k):
            print(f'{vecs[t][j]:>20.3f}', end = '')
            fout.write(f'{vecs[t][j]:>20.3f}')
        print()
        fout.write('\n')
    
    for t in range(ck_k):
        v = f'{var_names[i]}_{t}'
        genvars.append(v)
        fout.write(f"{v:>20s}")
        lmbd = vals[t]
        omg = np.reshape(vecs[:, t], (k, 1))
        z = H @ omg / ((lmbd/n)**0.5)
        z = np.reshape(z, len(z))
        genX.append(z)
    fout.write('\n')
 
genX = np.array(genX).T
fout.write('\nQuant. Vars...\n')
fout.write(f'{" ":>15s}')
for i in range(len(genvars)):
    fout.write(f'{genvars[i]:>15s}')
fout.write('\n')
for i in range(len(genX)):
    v = f'{case_id[i]:>15s}'
    fout.write(v)
    for v in genX[i]:
        fout.write(f'{v:>15.5f}')
    fout.write('\n')

QVars = {'case_id': case_id}
for i in range(len(genvars)):
    QVars[genvars[i]] = genX.T[i]

f_excel_nm = input('\nExcel File Name (*.xlsx) = ')
with pd.ExcelWriter(f_excel_nm) as writer:
    df = pd.DataFrame(QVars)
    df.to_excel(writer, index = False)
print(f_excel_nm, 'was saved.')

fout.close()
print(f'\n{fout_nm} was saved.\n')
